<?php

class actionIbackuperBackup extends cmsAction {

    public function run() {

        $data = array();
        $file_name = '';

        $form = $this->getForm('backup');

        if ($this->request->has('submit')){

            $ctype_id = $this->request->get('ctype_id', false);
            $iforms_id = $this->request->get('iforms_id', false);

            if (!$ctype_id && !$iforms_id){

                cmsUser::addSessionMessage(LANG_IBACKUPER_EMPTY, 'error');
                header('Refresh: 0');
                $this->halt();

            }

            if (!empty($ctype_id)){

                $data = cmsCore::getModel('ibackuper')->getCtype($ctype_id);

                if (!$data){

                    cmsUser::addSessionMessage(LANG_IBACKUPER_CTYPE_EMPTY, 'error');
                    header('Refresh: 0');
                    $this->halt();

                }

                $file_name = 'backuper_ctype_' . $data['ctype']['name'];

            }

            if (!empty($iforms_id) && cmsCore::isControllerExists('iforms')){

                $data = cmsCore::getModel('ibackuper')->getFormIforms($iforms_id);

                if (!$data){

                    cmsUser::addSessionMessage(LANG_IBACKUPER_IFORMS_EMPTY, 'error');
                    header('Refresh: 0');
                    $this->halt();

                }

                $file_name = 'backuper_iforms_' . $data['form']['name'];

            }

            $file = cmsConfig::get('upload_path') . 'ibackuper/' . $file_name . '.txt';

            file_put_contents($file, cmsModel::arrayToYaml($data), LOCK_EX);

            header("Content-Type: application/force-download");
            header("Content-Length: " . filesize($file));
            header('Content-Disposition: attachment; filename='.basename($file));
            header('Refresh: 0');

            if(ob_get_length()) { ob_end_clean(); }

            readfile($file);
            $this->halt();

        }

        return $this->cms_template->render('backend/backup', array(
            'form' => $form
        ));

    }

}
